﻿
Option Explicit On

'#If 0
'#End If

NameSpace MakeDelf


Friend Class frmMain
	Inherits System.Windows.Forms.Form 

	Friend lblFile			As System.Windows.Forms.Label
	Friend txtFile			As System.Windows.Forms.TextBox
	Friend cmdExec			As System.Windows.Forms.Button


	Public Sub New()
		' いちおーVisual Form Designer が認識するかも
		' 風にしておく。
		InitializeComponent()
	End Sub


	Private Sub InitializeComponent()

		With Me
			'.Location = New System.Drawing.Point( 50, 50 )
			.Size = New System.Drawing.Size( 450, 250 )
			.AutoScroll = true
			.TopMost = true
		End With
		
		Me.Text = "カスタムDelflate圧縮ツール"
		AddHandler Me.Load, AddressOf frmMain_Load
		AddHandler Me.FormClosing, AddressOf frmMain_FormClosing
		AddHandler Me.FormClosed, AddressOf frmMain_FormClosed


		lblFile = new System.Windows.Forms.Label
		lblFile.Bounds = new System.Drawing.Rectangle( 30, 30, 150, 20 )
		lblFile.Text = "圧縮するファイル一覧ファイル"
		Me.Controls.Add(Me.lblFile)


		txtFile = new System.Windows.Forms.TextBox
		txtFile.Bounds = New System.Drawing.Rectangle( _
			lblFile.Left, lblFile.Bottom+5 , 250,22 )
		txtFile.Text = "D:\dl\SubDesktop\sfcDev\tool\Bin2Text\map_start_512x512.zip"
		txtFile.AllowDrop = True
		AddHandler txtFile.DragEnter, AddressOf txtFile_DragEnter
		AddHandler txtFile.DragDrop, AddressOf txtFile_DragDrop
		Me.Controls.Add(Me.txtFile)



		cmdExec = new System.Windows.Forms.Button()
		cmdExec.Bounds = New System.Drawing.Rectangle( _
			txtFile.Right + 5, txtFile.Top, _ 
			50, 50 )
		cmdExec.Text = "実行"
		AddHandler cmdExec.Click, AddressOf cmdExec_Click
		Me.Controls.Add(Me.cmdExec)

	End Sub





	Private Sub txtFile_DragEnter( _
		ByVal sender As System.Object, _
		ByVal e As System.Windows.Forms.DragEventArgs)

		If e.Data.GetDataPresent(System.Windows.Forms.DataFormats.FileDrop) Then
			e.Effect = System.Windows.Forms.DragDropEffects.Copy
	    Else
			'string型でなければ受け入れない
			e.Effect = System.Windows.Forms.DragDropEffects.None
	    End If
	End Sub

	Private Sub txtFile_DragDrop( _
		ByVal sender As System.Object, _
		ByVal e As System.Windows.Forms.DragEventArgs)

		DragDropped( Me.txtFile, e )



	End Sub

	Private Sub DragDropped( ByRef txtDropped As System.Windows.Forms.TextBox, _ 
						  ByRef e As System.Windows.Forms.DragEventArgs)
		Dim strFileNames() as System.String
		
		strFileNames =CType (  e.Data.GetData( _ 
							System.Windows.Forms.DataFormats.FileDrop, false) , _
							String() )

		If strFileNames.Length > 1 Then
			' 幾つでも同時処理しちゃうぞ～～～～！
			txtDropped.Text = ""
			For each strFile as String In strFileNames
				txtDropped.Text &= """" + strFile + """ "
			Next
			
			' テキストボックスのマルチライン対応は・・・
			' とりあえずほっとこう。。。
		Else
			txtDropped.Text = strFileNames(0)
		End If

	End Sub





	Private Sub frmMain_Load( _
		ByVal sender As System.Object, _
		ByVal e As System.EventArgs)


			clsIniRW.Open()
			txtFile.Text = clsIniRW.IniKey_FilePath

	End Sub



	Private Sub frmMain_FormClosing( _
		ByVal sender As System.Object, _
		ByVal e As System.Windows.Forms.FormClosingEventArgs)

		'System.Windows.Forms.Messagebox.Show( "メインフォーム閉じる前。" )


	End Sub


	Private Sub frmMain_FormClosed( _
		ByVal sender As System.Object, _
		ByVal e As System.Windows.Forms.FormClosedEventArgs)


		clsIniRW.IniKey_FilePath = txtFile.Text

		'System.Windows.Forms.Messagebox.Show( "メインフォーム閉じる。" )
		clsIniRW.Close()

	End Sub



	Private Sub cmdExec_Click( _
		ByVal sender As System.Object, _
		ByVal e As System.EventArgs)


            Dim strFileName As String
		strFileName = System.IO.Path.ChangeExtension( _
								txtFile.Text  , "bin" )

		Dim fr As System.IO.FileStream
		Dim fw As System.IO.StreamWriter


		fr = Nothing
		fw = Nothing

		Try
			fr = new System.IO.FileStream( txtFile.Text, _
						System.IO.FileMode.Open )
		catch err As System.Exception
			System.Windows.Forms.MessageBox.Show( _
				"ファイルオープン失敗" )
			fr.Close()
			fr = Nothing
			Exit Sub
		End Try

		Try
			fw = new System.IO.StreamWriter( strFileName )
		catch err As System.Exception
			System.Windows.Forms.MessageBox.Show( _
				"ファイルオープン失敗" )
			fw.Close()
			fw.Dispose()
			fw = Nothing

			fr.Close()
			fr.Dispose()
			fr = Nothing
			Exit Sub
		End Try



		Dim bytRead			As Byte()
		
		
		bytRead = System.Array.CreateInstance( _
				GetType( System.Byte ), 256 )
		Dim nLineRead As Integer
		Dim nCnt As Integer
		Dim nAddr As Integer
		Dim nReaded As Integer
		
		nAddr = 0
		nLineRead = fr.Read( bytRead, 0, 256 )
		Do While nLineRead > 0
			
			nReaded = 0
			nCnt = 0
			Do While nLineRead > 0
				
				
				Do while nLineRead >= 16
					fw.Write( "{0,8:x8}:   ", nAddr )
					
					for nCnt = 0 to 15
						fw.Write( "{0,2:x2} ", bytRead( nReaded + nCnt ) )
						If nCnt = 7 Then
							fw.Write( "   " )
						End If
					next
					fw.WriteLine( "" )
					nReaded += 16
					nLineRead -= 16
					nAddr += &h10

				Loop
				
				If nLineRead > 0 Then
					' たぶん最終行じゃね？
					
					fw.Write( "{0,8:x8}:   " )
					for nCnt = 0 to nLineRead - 1
						fw.Write( "{0,2:x2} ", bytRead( nReaded + nCnt ) )
						If nCnt = 7 Then
							fw.Write( "   " )
						End If
					next
					fw.WriteLine( "" )
					nReaded += nLineRead
					nLineRead -= 16
					nAddr += nLineRead
				End If
				
				
			Loop
			
			nLineRead = fr.Read( bytRead, 0, 256 )
		Loop

		fr.Close()
		fw.Close()
		fr.Dispose()
		fw.Dispose()
		fr = Nothing
		fw = Nothing

	End Sub




End Class

#if 0

'Friend Class clsArrayHash(Of TKey, TValue)
Friend Class clsArrayHash(Of TKey, TValue)
	
	' キーで呼び出して、参照した複数のオブジェクトを参照する。
	' 確かシンボル名でハッシュしてたような
	' 呼び出しが高速だからインデックス参照代わりに使ってたんだよな。

	' 今回の利用では、圧縮前データの「各部分の先頭2バイト」を
	' 全部ハッシュキーにして、似たデータが無いか高速参照するのが
	' 目的。
	' ディクショナリ型が果たしてハッシュ値並みに高速参照するか
	' どうかは知らないけど…。
	
	' とりあえず add と、item ( 2バイトペア構造体 ) で登録されてるか
	' どうか、その元のバイトが何バイト目かが分かれば別に十分か?
	
	private mDictionary As System.Collections.Generic.Dictionary(Of TKey, System.Collections.Generic.List(Of TValue ) )
	
	Public Sub New()
		mDictionary = new System.Collections.Generic.Dictionary(Of TKey, System.Collections.Generic.List(Of TValue ) )()
	
	End Sub
	
	Public Sub Add(ByVal key As TKey, ByVal value As TValue )
	
		' http://programmers.high-way.info/vb/list-remove.html
		' うわList型の条件検索すっげー便利だわこのHPによると…。
		Dim glstValueList As System.Collections.Generic.List(Of TValue)
	
		If mDictionary.ContainsKey( key ) = false Then
			glstValueList = new System.Collections.Generic.List(Of TValue )()

			mDictionary.Add( key, glstValueList )
		Else
			glstValueList = mDictionary( key )
		End If

		glstValueList.Add( value )


	End Sub

	Default ReadOnly Public Property Item( key As TKey ) As System.Collections.Generic.List(Of TValue)
	Get

		If mDictionary.ContainsKey( key ) = false Then
			Return Nothing
		Else
			Return mDictionary( key )
		End If

	End Get
	end Property


	Protected Overrides Sub Finalize()
		' 念のため傘下のList<T>を全部クリアしておく
		For Each value As System.Collections.Generic.List(Of TValue) In mDictionary.Values
			value.Clear()
		Next
	End Sub

End Class

#End If

Public Module HelloWorld
  Public Sub Main()
    Console.WriteLine("Hello, VB!")
    
    Dim frm1 as frmMain
    frm1 = new frmMain


    'System.Windows.Forms.MessageBox.Show( "AAA" )
    
    System.Windows.Forms.Application.DoEvents()

#if 0
	dim value as System.UInt16
	
		value = &hffff
		value += 1
		Console.WriteLine( "byte is {0:2X}", value )
		value = &h00
		value -= 1
		Console.WriteLine( "byte is {0:2X}", value )
		value -= 1
		Console.WriteLine( "byte is {0:2X}", value )


	return
#End If

#if 0

	’アレイ型ハッシュテーブルを試してみる。
	Dim arrayHash		As clsArrayHash(Of System.byte, Integer )
	arrayHash = New  clsArrayHash(Of System.byte, Integer )()


	' ２つ以上のジェネリック型を渡す、というのが無理なようだ。
	'arrayHash.Add(Of TKeya as System.byte, TValue as Integer )( &h00u , 100)
	'arrayHash.Add(Of TKey as System.byte)( 0 , 100)))))
	'arrayHash.Add( &h00u, 104 )

	arrayHash.Add( &haa, 3 )
	arrayHash.Add( &haa, 6 )
	arrayHash.Add( &haa, 10 )
	arrayHash.Add( &haa, 13 )
	arrayHash.Add( &h01, 8 )
	' 参照
	Dim list As System.Collections.Generic.List(Of Integer)
	list = arrayHash.Item( &haa )
	Console.WriteLine( 	"0xaa is : {0},{1}",  list(0), list(1) )
	Console.WriteLine( 	"0xaa is : {0},{1}",  list(2), list(3) )

	list = arrayHash.Item( &h01 )
	Console.WriteLine( 	"0x01 is : {0}",  list(0) )
#End If

	' null 設定できるのこれ？
	Dim bytTest		As System.Byte
	bytTest = Nothing

	If bytTest = &h0 Then
	    Console.WriteLine("bytTest Nothing is 0.")
	Else
	    Console.WriteLine("bytTest Nothing isNOT 0.")
	End If

    Console.WriteLine("bytTest is {0}", bytTest)


	'System.Windows.Forms.Application.Run( frm1 )

    Console.WriteLine("Ended.")

  End Sub
End Module



End NameSpace
